// Generated by CoffeeScript 1.6.3
(function() {
  var VoilaPlugin;

  module.exports = function(game, opts) {
    return new VoilaPlugin(game, opts);
  };

  module.exports.pluginInfo = {
    loadAfter: ['voxel-highlight', 'voxel-registry', 'voxel-registry', 'voxel-blockdata'],
    clientOnly: true
  };

  VoilaPlugin = (function() {
    function VoilaPlugin(game, opts) {
      var _ref, _ref1, _ref2;
      this.game = game;
      this.hl = (function() {
        var _ref1;
        if ((_ref = (_ref1 = this.game.plugins) != null ? _ref1.get('voxel-highlight') : void 0) != null) {
          return _ref;
        } else {
          throw 'voxel-voila requires voxel-highlight plugin';
        }
      }).call(this);
      this.registry = (function() {
        var _ref2;
        if ((_ref1 = (_ref2 = this.game.plugins) != null ? _ref2.get('voxel-registry') : void 0) != null) {
          return _ref1;
        } else {
          throw 'voxel-voila requires voxel-registry plugin';
        }
      }).call(this);
      if (this.registry.getItemDisplayName == null) {
        throw 'voxel-voila requires voxel-registry >=0.2.0 with getItemDisplayName';
      }
      this.blockdata = (_ref2 = this.game.plugins) != null ? _ref2.get('voxel-blockdata') : void 0;
      this.createNode();
      this.enable();
    }

    VoilaPlugin.prototype.createNode = function() {
      this.node = document.createElement('div');
      this.node.setAttribute('id', 'voxel-voila');
      this.node.setAttribute('style', '\
border: 1px solid black;\
background-image: linear-gradient(rgba(0,0,0,0.6) 0%, rgba(0,0,0,0.6) 100%);\
position: absolute;\
visibility: hidden;\
top: 0px;\
left: 50%;\
color: white;\
font-size: 18pt;\
');
      this.node.textContent = '';
      return document.body.appendChild(this.node);
    };

    VoilaPlugin.prototype.update = function(pos) {
      var bd, displayName, extra, id, name, x, y, z;
      this.lastPos = pos;
      id = this.game.getBlock(pos);
      name = this.registry.getBlockName(id);
      displayName = this.registry.getItemDisplayName(name);
      if (this.game.buttons.crouch) {
        if (this.blockdata != null) {
          x = pos[0], y = pos[1], z = pos[2];
          bd = this.blockdata.get(x, y, z);
          if (bd != null) {
            extra = "BD(" + x + "," + y + "," + y + "): " + (JSON.stringify(bd));
            window.status = extra;
            console.log(extra);
            extra = '+';
          } else {
            extra = '';
          }
        }
        return this.node.textContent = "" + displayName + " (" + name + "/" + id + ")" + extra;
      } else {
        return this.node.textContent = displayName;
      }
    };

    VoilaPlugin.prototype.clear = function() {
      this.lastPos = void 0;
      return this.node.textContent = '';
    };

    VoilaPlugin.prototype.enable = function() {
      var _this = this;
      this.node.style.visibility = '';
      this.hl.on('highlight', this.onHighlight = function(pos) {
        return _this.update(pos);
      });
      this.hl.on('remove', this.onRemove = function() {
        return _this.clear();
      });
      if (this.game.buttons.changed != null) {
        return this.game.buttons.changed.on('crouch', this.onChanged = function() {
          return _this.update(_this.lastPos);
        });
      }
    };

    VoilaPlugin.prototype.disable = function() {
      this.hl.removeListener('highlight', this.onHighlight);
      this.hl.removeListener('remove', this.onRemove);
      if (this.game.buttons.changed != null) {
        this.game.buttons.changed.removeListener('crouch', this.onChanged);
      }
      return this.node.style.visibility = 'hidden';
    };

    return VoilaPlugin;

  })();

}).call(this);
